
## How to Install


```js

 $ npm install pm2-monitor
 $ npm install -g pm2-monitor

```

### Options

Pm2-monitor has several options, in order to change them access the config.js file
```js
server:{
    port:10022, //port that pm2 will be hosted
    host:'localhost' //if access is outside closed network, use real Ip Address,
    refresh: 2 //(seconds) refresh rate 

  },
  startup:{
    active:false, //enables creation of startup script
    path:'./pm2_startup.json' //location where startup script is generated
  },
  auth:
  {
    file:'./pm2_authfile' //do not change
  },
  logs:{

    active:false, //enables realtime logs (uses a lot of CPU)
    maxsize:1      //max size in MB of the log per process

  }
  notification:
  {
    email:{
      active:false, //activates notification by email
      limits:{

        memory:50, //Memory usage limit to send email
        cpu:50 //Cpu usage limit to send email

      },
      
      smtp:{
        host: 'smtp.yourserver.com', //setup your email provider
        port: 587, //provider port
        secure:false, //provider uses ssl or not
        ignoreTLS:true,
        auth: {
          user: 'username@email.com',
          pass: 'password'

        }
      },
      emailTo:'recipient', //email that will receive notifications
      emailFrom:'no-reply@email.com' //email to appear as sender
    },
    sms:{

      active:false, //activates notification by SMS
      tels:[
      {"gsm":"telephone"}, //celulars to receive notification
      {gsm:"telephone2"} 
      ],
      limits:{
        memory:80, 
        cpu:80
      },
      auth:{
        user:'username', //infoBIP username
        pass:'password' //infoBIP password
      }
      //In order to receive SMS, an infobip account must be created ...
      //http://br.infobip.com/

    },
    frequency:60 //(seconds) frequency that notifications will be sent (if limits are reached)
  }

```

### Starting pm2-monit

To start the process, you need to have pm2 up and running. 
```js

$ sudo node pm2_monitor.js //to start without authentication
$ sudo node pm2_monitor.js user password //to create user


//once an user is created, node pm2_monitor.js will start with authentication
//note that pm2_monitor may be started within pm2 
// sudo pm2 start pm2_monitor.js

```

### Graphs Description


```js

Total Memory Usage //displays the memory usage of the server running pm2-monitor
Total Cpu Usage //displays the cpu usage of the server running pm2-monitor

```


## License

MIT