var ipm2 = require('pm2-interface')(),
client,
util = require('os-utils'),
os = require('os'),
notification = require('./notification.js'),
shell = require('shelljs'),
fs= require('fs'),
config = require('../config.js');

module.exports = {

	setup:function(_client){

		ipm2.on('ready', function() {

			setInterval(getAllProcesses,config.server.refresh * 1000);

		});

		
		setInterval(updateGraphs,2000);

		client = _client;

		client.subscribe('/getdata', function(data) {

			switch(data.path)
			{
				case 'getdata':
				getAllProcesses();
				break;
				case 'stop':
				stopProcess(data.id);
				break;
				case 'start':
				startProcess(data.id);
				break;
				case 'restart':
				
				restartProcess(data.id);
				break;
				
				case"flush":
				shellCommand("pm2 flush");
				break;
				default:
				break;

			}

		});


	}

};

function startProcess  (pm_id)
{
	if(ipm2.rpc.startProcessId === undefined)
		return;
	ipm2.rpc.startProcessId(pm_id, getAllProcesses);

}

function stopProcess(pm_id)
{
	if(ipm2.rpc.stopProcessId === undefined)
		return;

	ipm2.rpc.stopProcessId(pm_id, getAllProcesses);

}

function restartProcess(pm_id)
{

	if(ipm2.rpc.restartProcessId === undefined)
		return;
	ipm2.rpc.restartProcessId(pm_id, getAllProcesses);


}

function shellCommand(_command)
{

	shell.exec(_command);
}

function updateGraphs(){



	util.cpuUsage(function(use){


		var data = {

			Memory:Number(((os.totalmem() - os.freemem())/(1024*1024*1024)).toFixed(2)),
			Cpu:Number((use*100).toFixed(2)),
			TotalMem:Number(((os.totalmem()/(1024*1024*1024)).toFixed(2)))


		};

		transmitDataGraphs(data);
		notification.sendNotification(data);


	});

}

function getAllProcesses(){


	if(ipm2.rpc.getMonitorData === undefined)
		return;

	ipm2.rpc.getMonitorData({}, function(err, dt) {


		var rprocess = [];
		var startup=[];
		for (var item in dt)
		{

			var obj = {

				id : dt[item].pm_id,
				name:dt[item].name,
				restart:dt[item].pm2_env.restart_time,
				uptime:dt[item].pm2_env.pm_uptime,
				pid:dt[item].pid,
				memory:dt[item].monit.memory,
				cpu:dt[item].monit.cpu,
				status:dt[item].pm2_env.status,
				log:config.logs.active ?(fs.readFileSync(dt[item].pm2_env.pm_out_log_path).length > (config.logs.maxsize*1024*1024) ? "Log muito grande , maior que 1 MB":fs.readFileSync(dt[item].pm2_env.pm_out_log_path).toString()):"",
				totalmem:os.totalmem()


			};

			startup.push({

				name:obj.name,
				script:dt[item].pm2_env.pm_exec_path,
				args:"",
				exec_mode:"fork_mode"


			});
			rprocess.push(obj);

		}
		if(config.startup.active && !fs.existsSync(config.startup.path))
		{
			try
			{
				
				fs.writeFileSync(config.startup.path,JSON.stringify(startup));
			}
			catch(e)
			{
				console.log(e);
			}

		}

		transmitData(rprocess);

		startup=[];
		rprocess=[];
	});


}

function transmitData(data){

	client.publish('/updates', {
		Data: data
	});

}
function transmitDataGraphs(data)
{

	client.publish('/graphs', {
		Data: data
	});

}




