/*jshint multistr: true */

var config = require('../config.js'),
useful = require("./useful.js"),
nodemailer = require('nodemailer'),
smtpTransport = require('nodemailer-smtp-transport'),
http = require('http');

var filaEmail = [];
var filaSMS= [];


if(config.notification.email.active || config.notification.sms.active)
  setInterval(processFila,config.notification.frequency * 1000);

var main =
{


  sendNotification: function(data){

    var obj;
    var stringEmail = "-------------------------------\n\
    Memory Use {0} % | Limit {1} % \n\
    -------------------------------\n\
    Cpu Use    {2} % | Limit {3} %\n\
    -------------------------------";

    var stringSms = "Memory Use {0} % | Limit {1} % \n\
    Cpu Use    {2} % | Limit {3} %\n";
    
    
    if(config.notification.email.active && filaEmail.length === 0 && (data.Memory /data.TotalMem) * 100 > (config.notification.email.limits.memory||data.Cpu > config.notification.email.limits.cpu))
    {

      obj =
      {

        Message: stringEmail.template("{0}",((data.Memory /data.TotalMem) * 100).toFixed(2))
        .template("{1}",config.notification.email.limits.memory)
        .template("{2}",data.Cpu)
        .template("{3}",config.notification.email.limits.cpu)

      };
      
      filaEmail.push(obj);

    }



    if(config.notification.sms.active && filaSMS.length === 0 && (data.Memory /data.TotalMem) * 100 > (config.notification.sms.limits.memory||data.Cpu > config.notification.sms.limits.cpu))
    {

     obj =
     {

      Message: stringSms.template("{0}",((data.Memory /data.TotalMem) * 100).toFixed(2))
      .template("{1}",config.notification.sms.limits.memory)
      .template("{2}",data.Cpu)
      .template("{3}",config.notification.sms.limits.cpu)

    };
    filaSMS.push(obj);
  }


},

sendSMS :function ( message) {

  var data = {
    "authentication": {
      "username": config.notification.sms.auth.user,
      "password": config.notification.sms.auth.pass
    },
    "messages": [{
      "sender": "Pm2Monitor",
      "text": message,
      "recipients": config.notification.sms.tels
    }]
  };
  
  var options = {

    host: 'api2.infobip.com',
    headers: {

      "Content-Type": "application/json",
      "Content-Length": JSON.stringify(data).length
    },
    path: "/api/v3/sendsms/json",
    method: "POST"


  };


  _callback = function(response) {
    var str = '';
    response.on('data', function(chunk) {
      str += chunk;
    });

    response.on('end', function() {

      var result = JSON.parse(str);

      var responseS = createResponse(result);

      for(var item in responseS)
      {

        console.log(responseS[item].errorMessage);

      }

    });
  };

  var req = http.request(options, _callback);

  req.write(JSON.stringify(data));
  req.end();
  req.on('error', function(e) {

    console.log('Error sending sms');
  });


},

sendEmail :function (_text)
{

  var transporter = nodemailer.createTransport(smtpTransport(config.notification.email.smtp));

  transporter.sendMail({
    from: config.notification.email.emailFrom,
    to: config.notification.email.emailTo,
    subject: 'Server Alert',
    text: _text
  },function(err,result){
    if(err || result.rejected.length > 0)
    {
      console.log('Error sending email, error:'+err);
      return;
    }

    console.log('Email Sent');


  });

}
};


function createResponse(data){

  var responseArray = [];
  var allStatus = data.results;

  for(var item in allStatus)
  {
    var obj = allStatus[item];

    var jsonResult =
    {

      status: 200,
      errorMessage: "SMS sent"

    };
    switch (obj.status) {

      case "-2":
      jsonResult.errorMessage = "Not enough credits";
      jsonResult.status = 500;
      break;

      case "-22":
      jsonResult.errorMessage = "Incorrect JSON format";
      jsonResult.status = 500;
      break;
      case "0":
      
      break;
      default:
      jsonResult.errorMessage = "Internal Error";
      jsonResult.status = 500;
      break;

    }

    responseArray.push(jsonResult);

  }

  return responseArray;
}



function processFila(){


  if(filaEmail.length > 0)
  {

    main.sendEmail(filaEmail[0].Message);
    
    filaEmailMemory = [];

  }
  

  if(filaSMS.length > 0)
  {

    main.sendSMS(filaSMS[0].Message);
    

    filaSMSCPU = [];
  }

}

module.exports =main;

