#!/usr/bin/env node

var fs= require('fs'),
http = require('http'),
faye = require('faye'),
config = require('./config.js'),
auth = require("http-auth"),
cmd = require('./libs/interaction.js'),
useful = require('./libs/useful.js');


process.on('uncaughtException',function(err){

  console.log("Error: ",err);
  process.kill();

});

function main(){

  var hash,
  basic,
  bayeuxServer ,
  bayeux,
  file;

  if(process.argv.length > 2)
  {

    var usuario = process.argv[2];
    var senha = process.argv[3];
    senha = senha === undefined ?"":senha;
    senha = senha.toMd5();

    fs.writeFileSync("./pm2_authfile",usuario+":"+senha);
    config.auth.file = "./pm2_authfile";


  }

  if(fs.existsSync(config.auth.file)){

    config.auth.required = true;

    
    file = fs.readFileSync(config.auth.file).toString();
    hash = file.toMd5();

    
    basic = auth.basic({
      realm: "Monitoring Area"
    }, function (username, password, callback) {


      var usr = file.split(':')[0];
      var pwd = file.split(':')[1];

      callback(username === usr && pwd ===password.toMd5());

    });

  }
  else
  {

    hash = Math.random().toString().toMd5();

  }


  bayeux = new faye.NodeAdapter({mount: '/'+hash, timeout: 45});
  

  var callback= function(req,res)
  {

    switch(req.url)
    {

      case "/scripts/main_scripts.js":
      {

        res.writeHead(200, {"Content-Type": "text/javascript"});
        res.end(fs.readFileSync(__dirname+"/scripts/main_scripts.min.js"));

      }
      break;
      case "/app":
      {
        var resultJson = {

          hash:hash,
          events:{

            send:[ "updates","graphs"],
            receive:["getdate"]

          }
        };
        res.writeHead(200, {"Content-Type": "application/json"});
        res.end(JSON.stringify(resultJson));

      }
      break;
      default:
      {
        var html = fs.readFileSync(__dirname+'/views/Index.html').toString();

        html = html.template('{0}',config.server.host).template('{1}',config.server.port).template('{2}',hash);
        
        res.writeHead(200, {"Content-Type": "text/html"});
        res.end(html);
      }
      break;
    }
  };

  
  

  bayeuxServer = config.auth.required? http.createServer(basic,callback):http.createServer(callback);
  bayeux.attach(bayeuxServer);

  bayeuxServer.listen(config.server.port);
  console.log("Listening on port: "+config.server.port);

  client = new faye.Client('http://localhost:'+config.server.port+'/'+hash);

  cmd.setup(client);

}

main();



